package ee.asynchat;

import jakarta.annotation.PostConstruct;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Named;

import java.util.ArrayList;
import java.util.List;

@Named
@ApplicationScoped
public class JsfAsync
{
    private List<String> messages;
    private Object wakeup;

    @PostConstruct
    public void init()
    {
        wakeup = new Object();
        messages = new ArrayList<String>();
    }

    public void setNewMessage(String msg)
    {
        synchronized(messages)
        {
            messages.add(msg);
        }
    }

    public void say()
    {
        synchronized(wakeup)
        {
            wakeup.notifyAll();
        }
    }

    public String resend()
    {
       try {
            synchronized(wakeup)
            {
                wakeup.wait(30000);
            }
        } catch (Exception e) { }
        return "index";
    }

    public void clear()
    {
        synchronized(messages)
        {
            messages.clear();
        }
        say();
    }

    public String getNewMessage()
    {
        return "";
    }

    public String getMsgs()
    {
        StringBuilder msgs = new StringBuilder();
        synchronized(messages)
        {
            for (String m : messages)
            {
                msgs.append(m);
                msgs.append("<br/>");
            }
            return msgs.toString();
        }
    }
}
